#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <errno.h>
#include <string.h>

#include "config.h"
#include "dammit.h"

unsigned long wait = WAIT;
int fd;
void sigint( int sig );
void speedchg( int sig );

int main() {
	unsigned char light = 1;
	unsigned char direction = 1;
	unsigned long int mask;

	fd = open( "/dev/dammit2" , O_WRONLY );
	if( fd < 0 ) {
		printf( "Couldn't get access to the DAMMIT device!\n" );
		return 1;
	}

	if( ioctl( fd, DAMMIT_SET_MULTI, 4 ) != 0 ) {
		printf( "Error on ioctl. %s\n", strerror( errno ) );
		exit( 1 );
	}
	signal( SIGINT, sigint );
	signal( SIGUSR1, speedchg );
	signal( SIGUSR2, speedchg );

	while( 1 ) {
		mask = 1 << light;
		write( fd, &mask, 4 );
		if( ( light == 0 ) || ( light == 32 - 1) ) {
			direction = direction * - 1;
		}
		light += direction;
		usleep( wait ) ;
	}
	close( fd );
	return 0;
}

void sigint( int sig ) {
	unsigned long int mask = 0;
	printf( "exiting on SIGINT\n" );
	
	write( fd, &mask, 4 );
	close(fd);
	exit( 0 );
}

void speedchg( int sig ) {
	if( sig == SIGUSR1 ) {
		wait += 50000;
		printf( "Increased interval\n" );
	}
	else {
		wait -= 50000;
		printf( "Decreased interval\n" );
	}
}	
