#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

#include "config.h"

FILE *fd;
unsigned long wait = WAIT;

void sigint( int sig );
void speedchg( int sig );

int main() {
	unsigned char light = 0;
	unsigned char mask;

	fd = fopen( DAMMITDEV, "w" );
	if( fd == NULL ) {
		printf( "Couldn't get access to the DAMMIT device!\n" );
		return 1;
	}

	signal( SIGINT, sigint );
	signal( SIGUSR1, speedchg );
	signal( SIGUSR2, speedchg );

	while( 1 ) {
		mask = 1 << light;
		fwrite( &mask, 1, 1, fd );
		fflush( fd );
		light++;
		if( light == 3 ) {
			light = 0;
		}
		usleep( wait ) ;
	}
	fclose( fd );
	return 0;
}

void sigint( int sig ) {
	unsigned char mask = 0;
	printf( "exiting on SIGINT\n" );
	
	fwrite( &mask, 1, 1, fd );
	fclose(fd);
	exit( 0 );
}

void speedchg( int sig ) {
	if( sig == SIGUSR1 ) {
		wait += 50000;
		printf( "Increased interval\n" );
	}
	else {
		wait -= 50000;
		printf( "Decreased interval\n" );
	}
}	
